<?php

namespace ACL\Repositories;

use ACL\Traits\TQuery;
use Doctrine\ORM\EntityManager;

class Tabela extends RepositoryBase {

    Use TQuery;

    protected $table = 'TABELA';

    /** @var EntityManager */
    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        parent::__construct($this->table);
        $this->entityManager = $entityManager;
    }

    /**
     * @param $nrorg
     * @return array
     */
    public function findAllTabela($nrorg): array
    {
        $query = "SELECT NMTABELABD, DSTABELABD    
                    FROM TABELA
                    WHERE NRORG = :NRORG
                    UNION ALL
                  SELECT 'RECALCULO'  AS NMTABELABD, 'Recalculo de Estoque' AS DSTABELABD    
                    FROM DUAL";

        $params = array(
            "NRORG" => $nrorg
        );

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $query, $params);
    }
}
