<?php

namespace ACL\Repositories;

use ACL\Traits\TQuery;
use ACL\Helpers\Instances\InstanceProvider;
use Doctrine\DBAL\Exception;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DBAL\Connection;

class ZhuAcl
{

    Use TQuery;

    /** @var EntityManager */
    protected $entityManager;

    public function __construct()
    {
        $this->entityManager = InstanceProvider::getEntityManager();
    }

    /**
     * @param $projectId
     * @param $nrperfilacesso
     * @param $nrorg
     * @return array
     * @throws Exception
     */
    public function getElementsByNrperfilacesso($projectId, $nrperfilacesso, $nrorg): array
    {
        $query = <<<SQL
             SELECT RULE.ID, RULE.NAME, RULE.RULE,
                    ELEMENT.LABEL, ELEMENT.UNIQUE_ID, ELEMENT.PROJECT_ID, ELEMENT.TYPE
               FROM ZHU_ACCESS_CONTROL_RULE RULE 
               JOIN ZHU_ACCESS_CONTROL_ELEMENT ELEMENT ON RULE.ACCESS_CONTROL_ELEMENT_ID = ELEMENT.ID 
              WHERE ELEMENT.PROJECT_ID = :PROJECT_ID 
                AND RULE.ORGANIZATION_ID = :ORGANIZATION_ID
                AND RULE.GROUP_ID = :GROUP_ID
                AND RULE.RULE = 'A'
                AND ELEMENT.TYPE IN ('M', 'C')
SQL;
        $params = array(
            "PROJECT_ID" => $projectId,
            'GROUP_ID' => $nrperfilacesso,
            'ORGANIZATION_ID' => $nrorg,
        );

        return $this->entityManager->getConnection()->fetchAllAssociative($query, $params);
    }


}
