<?php

namespace ACL\Services;

use ACL\Helpers\Instances\InstanceProvider;
use ACL\Repositories\Perfacessparc as PerfacessparcRepository;
use Exception;

class Perfacessparc {

    /**
     * @var \Teknisa\Libs\Util\Environment
     */
    private $libEnvironment;

    /**
     * @var PerfacessparcRepository
     */
    private $perfacessparcRepository;

    public function __construct(PerfacessparcRepository $perfacessparcRepository)
    {
        $this->perfacessparcRepository = $perfacessparcRepository;
        $this->libEnvironment =  InstanceProvider::getLibEnvironment();
    }

    /**
     * @param $rows
     * @return array
     * @throws \Doctrine\DBAL\Driver\Exception
     * @throws \Doctrine\DBAL\Exception
     */
    public function savePerfaccessparc($rows): array
    {
        $organizationId = $this->libEnvironment->getCurrentOrganizationId();

        foreach ($rows as $row) {
            $this->setParcnegocio($row);

            $row['NRPERFACESSPARC'] = InstanceProvider::getNewCode()->getCodeByTableName('PERFACESSPARC', $organizationId);
            $row = $this->perfacessparcRepository->auditValuesFieldArrayMerge($row,
                                                                        $this->perfacessparcRepository->getAuditFieldValuesDefaultInsert());
            $this->perfacessparcRepository->savePerfaccessparc($row['NRPERFACESSPARC'], $row['NRORG'],
                                                                $row['NRPARCNEGOCIO'], $row['NRPERFILACESSO'],
                                                                $row['CDOPERINCLUSAO'], $row['DTVALIDADE']);
        }
        return [];
    }

    /**
     * @param $params
     * @return array
     * @throws Exception|\Doctrine\DBAL\Driver\Exception
     */
    public function updatePerfaccessparc($params): array
    {
        foreach ($params as $row) {
            $this->perfacessparcRepository->updatePerfaccessparc(
                $row['NRPERFACESSPARC'], $row['DTVALIDADE'], getNrorg()
            );
        }
        return [];
    }

    public function deletePerfaccessparc($rows)
    {
        foreach ($rows as $row) {
            $this->perfacessparcRepository->deletePerfaccessparc($row['NRPERFACESSPARC'], getNrorg());
        }
    }

    private function setParcnegocio(&$row)
    {
        $parcnegocioService = InstanceProvider::getService()->getParcnegocio();
        $cdtipoinscricao = 'LIVRE';
        $nrinscricaoparc = null;

        if (!$row['NRPARCNEGOCIO']) {
            $data = $parcnegocioService->setParcnegocio($row['NMOPERADOR'], $nrinscricaoparc,
                $cdtipoinscricao, $row['CDOPERADOR']);
            $row['NRPARCNEGOCIO'] = $data['NRPARCNEGOCIO'];
        }
    }
}
