CREATE OR REPLACE PROCEDURE SALDO_LALUR_PARTEB(
   P_CDEMPRESA IN EMPRESA.CDEMPRESA%TYPE,
   P_CDCONTCTBL IN CONTCTBL.CDCONTCTBL%TYPE)
IS
   V_SALDO NUMBER;
   V_SALDOANTERIOR NUMBER;
   V_DATAMAXRECALC DATE;
   V_DATAMINRECALC DATE;
   V_DATAAUX DATE;
   V_COUNT NUMBER;
   V_DATAINICIAL DATE;
   V_DATAFINAL DATE;
   V_EXISTELANC VARCHAR(01);

BEGIN
   V_COUNT := 0;
   /* Ano que comeou a entrega das ecfs -1, caso a empresa faa a implantao de saldo controlado */
   V_DATAMINRECALC := TO_DATE('01/01/2014');

   BEGIN
      SELECT COUNT(*)
        INTO V_COUNT
        FROM LALURPARTEB
       WHERE CDEMPRESA = P_CDEMPRESA;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_COUNT := 0;
   END;
   IF V_COUNT = 0 THEN
      BEGIN
         SELECT COUNT(*)
           INTO V_COUNT
           FROM LALURBSREFLEXA
          WHERE CDEMPRESA = P_CDEMPRESA;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_COUNT := 0;
      END;
   END IF;

   IF V_COUNT <> 0 THEN
      BEGIN
         SELECT LAST_DAY(MAX(LB.DTLANCAMENT))
           INTO V_DATAAUX
           FROM LALURPARTEB LB
          WHERE LB.CDEMPRESA = P_CDEMPRESA;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_DATAAUX := NULL;
      END;

      V_DATAMAXRECALC := NULL;
      BEGIN
         SELECT LAST_DAY(MAX(LS.DTLANCAMENT))
           INTO V_DATAMAXRECALC
           FROM LALURBSREFLEXA LS
          WHERE LS.CDEMPRESA = P_CDEMPRESA
            AND CDCONTCTBLB = P_CDCONTCTBL;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_DATAMAXRECALC := NULL;
      END;
      IF ((V_DATAMAXRECALC IS NULL) OR (V_DATAAUX > V_DATAMAXRECALC)) THEN
         V_DATAMAXRECALC := V_DATAAUX;
      END IF;
      V_DATAMAXRECALC := TO_DATE('31/12/'||TO_CHAR(V_DATAMAXRECALC, 'YYYY'));
   ELSE
     V_DATAMAXRECALC := TO_DATE('31/12/'||TO_CHAR(SYSDATE, 'YYYY'));
   END IF;

   DELETE
     FROM SALDLALURB
    WHERE CDEMPRESA = P_CDEMPRESA
      AND CDCONTCTBL = P_CDCONTCTBL
      AND DTSALDPER BETWEEN V_DATAMINRECALC AND V_DATAMAXRECALC;

   V_DATAINICIAL := TO_DATE('01/'||TO_CHAR(V_DATAMINRECALC, 'MM/YYYY'));
   WHILE V_DATAINICIAL <= V_DATAMAXRECALC LOOP
      V_DATAINICIAL := TO_DATE('01/'||TO_CHAR(V_DATAINICIAL, 'MM/YYYY'));
      V_DATAFINAL := LAST_DAY(V_DATAINICIAL);
      V_EXISTELANC := 'N';
      FOR C_SALDOS IN
         (SELECT NVL(SUM(VRCOMREFLEXO), 0) + NVL(SUM(VRSEMREFLEXO), 0) VRSALDOPER, CDCONTCTBL, IDTRIBUTO
            FROM (SELECT NVL(ROUND(SUM(LB.VRDEBITO), 2)*-1, 0) + NVL(ROUND(SUM(LB.VRCREDITO), 2), 0) AS VRCOMREFLEXO,
                         0 AS VRSEMREFLEXO,
                         CDCONTCTBL, IDTRIBUTO
                    FROM LALURPARTEB LB
                   WHERE DTLANCAMENT BETWEEN V_DATAINICIAL AND V_DATAFINAL
                     AND CDEMPRESA = P_CDEMPRESA
                     AND CDCONTCTBL = P_CDCONTCTBL
                     AND IDTRIBUTO = 'I'
                   GROUP BY CDCONTCTBL, IDTRIBUTO
                   UNION
                  SELECT 0 AS VRCOMREFLEXO, NVL(ROUND(SUM(VRLANCAMENT), 2), 0)*-1 AS VRSEMREFLEXO,
                              CDCONTCTBLB CDCONTCTBL, IDTRIBUTO
                    FROM LALURBSREFLEXA LB
                   WHERE DTLANCAMENT BETWEEN V_DATAINICIAL AND V_DATAFINAL
                     AND CDEMPRESA = P_CDEMPRESA
                     AND CDCONTCTBLB = P_CDCONTCTBL
                     AND IDTRIBUTO = 'I'
                   GROUP BY CDCONTCTBLB, IDTRIBUTO)
            GROUP BY CDCONTCTBL, IDTRIBUTO) LOOP

         V_SALDOANTERIOR := 0;
         BEGIN
            SELECT VRSALDFIN
              INTO V_SALDOANTERIOR
              FROM SALDLALURB
             WHERE CDEMPRESA = P_CDEMPRESA
               AND DTSALDPER = (V_DATAINICIAL-1)
               AND CDCONTCTBL = C_SALDOS.CDCONTCTBL
               AND IDTRIBUTO = C_SALDOS.IDTRIBUTO;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_SALDOANTERIOR := 0;
         END;

         V_SALDO := NVL(ROUND(V_SALDOANTERIOR, 2), 0) + NVL(ROUND(C_SALDOS.VRSALDOPER, 2), 0);

         INSERT INTO SALDLALURB
            (CDEMPRESA, DTSALDPER, CDCONTCTBL,
             VRSALDINI, VRSALDPER, VRSALDFIN, IDTRIBUTO)
         VALUES
            (P_CDEMPRESA, V_DATAFINAL, C_SALDOS.CDCONTCTBL,
             V_SALDOANTERIOR, C_SALDOS.VRSALDOPER, V_SALDO, C_SALDOS.IDTRIBUTO);
         V_EXISTELANC := 'S';
      END LOOP;
      IF V_EXISTELANC = 'N' THEN
         FOR ATU_SALDO IN
            (SELECT VRSALDFIN, 'I' IDTRIBUTO, DTSALDPER
               FROM SALDLALURB
              WHERE CDEMPRESA = P_CDEMPRESA
                AND CDCONTCTBL = P_CDCONTCTBL
                AND IDTRIBUTO = 'I'
                AND DTSALDPER = (V_DATAINICIAL-1)) LOOP
            INSERT INTO SALDLALURB
               (CDEMPRESA, CDCONTCTBL, DTSALDPER, VRSALDINI, VRSALDPER, VRSALDFIN, IDTRIBUTO)
            VALUES
               (P_CDEMPRESA, P_CDCONTCTBL, V_DATAFINAL, ATU_SALDO.VRSALDFIN, 0, ATU_SALDO.VRSALDFIN, ATU_SALDO.IDTRIBUTO);
         END LOOP;
      END IF;

      V_EXISTELANC := 'N';
      FOR C_SALDOS IN
         (SELECT NVL(SUM(VRCOMREFLEXO), 0) + NVL(SUM(VRSEMREFLEXO), 0) VRSALDOPER, CDCONTCTBL, IDTRIBUTO
            FROM (SELECT NVL(ROUND(SUM(LB.VRDEBITO), 2)*-1, 0) + NVL(ROUND(SUM(LB.VRCREDITO), 2), 0) AS VRCOMREFLEXO,
                         0 AS VRSEMREFLEXO, CDCONTCTBL, IDTRIBUTO
                    FROM LALURPARTEB LB
                   WHERE DTLANCAMENT BETWEEN V_DATAINICIAL AND V_DATAFINAL
                     AND CDEMPRESA = P_CDEMPRESA
                     AND CDCONTCTBL = P_CDCONTCTBL
                     AND IDTRIBUTO = 'C'
                   GROUP BY CDCONTCTBL, IDTRIBUTO
                   UNION
                  SELECT 0 AS VRCOMREFLEXO, NVL(ROUND(SUM(VRLANCAMENT), 2), 0)*-1 AS VRSEMREFLEXO,
                         CDCONTCTBLB CDCONTCTBL, IDTRIBUTO
                    FROM LALURBSREFLEXA LB
                   WHERE DTLANCAMENT BETWEEN V_DATAINICIAL AND V_DATAFINAL
                     AND CDEMPRESA = P_CDEMPRESA
                     AND CDCONTCTBLB = P_CDCONTCTBL
                     AND IDTRIBUTO = 'C'
                   GROUP BY CDCONTCTBLB, IDTRIBUTO)
            GROUP BY CDCONTCTBL, IDTRIBUTO) LOOP

         V_SALDOANTERIOR := 0;
         BEGIN
            SELECT VRSALDFIN
              INTO V_SALDOANTERIOR
              FROM SALDLALURB
             WHERE CDEMPRESA = P_CDEMPRESA
               AND DTSALDPER = (V_DATAINICIAL-1)
               AND CDCONTCTBL = C_SALDOS.CDCONTCTBL
               AND IDTRIBUTO = C_SALDOS.IDTRIBUTO;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_SALDOANTERIOR := 0;
         END;

         V_SALDO := NVL(ROUND(V_SALDOANTERIOR, 2), 0) + NVL(ROUND(C_SALDOS.VRSALDOPER, 2), 0);

         INSERT INTO SALDLALURB
            (CDEMPRESA, DTSALDPER, CDCONTCTBL,
             VRSALDINI, VRSALDPER, VRSALDFIN, IDTRIBUTO)
         VALUES
            (P_CDEMPRESA, V_DATAFINAL, C_SALDOS.CDCONTCTBL,
             V_SALDOANTERIOR, C_SALDOS.VRSALDOPER, V_SALDO, C_SALDOS.IDTRIBUTO);
         V_EXISTELANC := 'S';
      END LOOP;
      IF V_EXISTELANC = 'N' THEN
         FOR ATU_SALDO IN
            (SELECT VRSALDFIN, 'C' IDTRIBUTO, DTSALDPER
               FROM SALDLALURB
              WHERE CDEMPRESA = P_CDEMPRESA
                AND CDCONTCTBL = P_CDCONTCTBL
                AND IDTRIBUTO = 'C'
                AND DTSALDPER = (V_DATAINICIAL-1)) LOOP
            INSERT INTO SALDLALURB
               (CDEMPRESA, CDCONTCTBL, DTSALDPER, VRSALDINI, VRSALDPER, VRSALDFIN, IDTRIBUTO)
            VALUES
               (P_CDEMPRESA, P_CDCONTCTBL, V_DATAFINAL, ATU_SALDO.VRSALDFIN, 0, ATU_SALDO.VRSALDFIN, ATU_SALDO.IDTRIBUTO);
         END LOOP;
      END IF;

      V_DATAINICIAL := ADD_MONTHS(V_DATAINICIAL, 1);
   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('SALDO_LALUR_PARTEB','5.85.xxx'); END;
/

